<template>
	<div class="main">
		<v-snackbar v-model="snackbar" class="subtitle-1" top right color="#c51f2f">{{messageSnackbar}}</v-snackbar>
		<p class="display-1 white--text">Sistema de impulso al talento</p>
		<v-card elevation="20" color="grey lighten-3">
			<v-card-text>
				<v-row>
					<v-col>
						<img src="../assets/cozcytLogo.png" />
					</v-col>
				</v-row>
				<v-row>
					<v-col>
						<v-form ref="formLogin" v-model="isValid">
							<v-card outlined>
								<v-card-title class="textCenter">Iniciar sesión</v-card-title>
								<v-card-text>
									<v-text-field
										id="curp"
										prepend-icon="fas fa-id-card"
										:rules="rulesCURP"
										label="CURP"
										outlined
										v-model="user.curp"
										required
									/>
									<v-text-field
										prepend-icon="fas fa-key"
										:rules="rulesPass"
										label="Contraseña"
										outlined
										:append-icon="showPass ? 'fa-eye' : 'fa-eye-slash'"
										:type="showPass ? 'text' : 'password'"
										@click:append="showPass = !showPass"
										@keydown.enter="catchEnter"
										v-model="user.pass"
										required
									/>
									<v-row>
										<v-btn :disabled="!isValid" block rounded color="success" @click="login(user)">Ingresar</v-btn>
									</v-row>
								</v-card-text>
							</v-card>
						</v-form>
					</v-col>
				</v-row>
				<a class="body-1 mb-1 textCenter" @click="openFormRegister">¿No tienes cuenta? Regístrate ahora</a>
				<a class="body-1 textCenter" @click="showRecoverPassword">¿Olvidaste tu contraseña? Actualízala</a>
			</v-card-text>
		</v-card>

		<FormRegister :displayForm="visible" />
		<FormRecoverPassword :visible="visibleRecover" />
		<Footer />
	</div>
</template>

<script>
import EventBus from "../bus";
import Footer from '@/components/Footer.vue';
import FormRegister from "@/components/student/FormRegister.vue";
import FormRecoverPassword from "@/components/student/FormRecoverPassword.vue";
import { mapActions } from "vuex";

export default {
	name: "Login",
	components: { FormRegister, Footer, FormRecoverPassword },
	data: () => ({
		isValid: true,
		snackbar: false,
		user: {
			curp: "",
			pass: ""
		},
		visible: null,
		visibleRecover: false,
		showPass: false,
		rulesPass: [
			value => !!value || "Campo requerido",
			value => (value || "").length >= 8 || "Mínimo 8 carácteres"
		],
		rulesCURP: [
			value => !!value || "Campo requerido",
			value =>
				(value || "").length === 18 || "18 carácteres obligatorios",
			value => {
				const patternName = /[`~!@#$%^&*()_°¬|+\-=?;:'",<>\{\}\[\]\\\/]/gi;
				return !patternName.test(value) || "Solo letras y números";
			}
		],
		messageSnackbar: ""
	}),
	watch: {
		// escucha el input curp y transforma el texto a mayusculas
		user: {
			handler(val, oldVal) {
				if (this.user.curp !== undefined) {
					this.user.curp = this.user.curp.toUpperCase();
				}
			},
			deep: true
		}
	},
	methods: {
		...mapActions(["login"]),

		openFormRegister() {
			this.visible = true;
			this.$refs.formLogin.reset();
		},
		catchEnter(){
			if(this.user.pass.length >= 8){
				this.login(this.user);
			}
		},
		showRecoverPassword(){
			this.visibleRecover = true;
		}
	},
	mounted() {
		EventBus.$on("closeFormRegister", () => {
			this.visible = false;
		});

		EventBus.$on("errorLogin", message => {
			this.messageSnackbar = message;
			this.snackbar = true;
			setTimeout(() => {
				this.snackbar = false;
			}, 3000);
		});

		EventBus.$on("closeRecoverPassword",() => {
			this.visibleRecover = false;
		});
	}
};
</script>

<style scope>
.main {
	background-color: #558b2f;
	height: 100%;
	display: flex;
	flex-direction: column;
	align-items: center;
	justify-content: center;
}
.textCenter {
	display: flex;
	justify-content: center;
}

#curp {
	text-transform: uppercase;
}
.a {
	display: flex;
	align-items: center;
}
.chiquito {
	font-size: 10px;
}
</style>